import { ReadonlyDeep } from "type-fest";
import Camera, { ControlName, ControlRange, ControlValue, ControlValues } from "uvc-control";
import CameraControlHelper from "./camera-control-helper";
import Output from "./output";
import { UvccControls } from "./types/controls";
export declare type ControlsValues = Record<string, ControlValues>;
export declare type ControlRanges = Record<string, ControlRange>;
export default class CameraHelper {
    private readonly output;
    private readonly cameraControlHelper;
    private readonly camera;
    constructor(output: ReadonlyDeep<Output>, cameraControlHelper: ReadonlyDeep<CameraControlHelper>, camera: ReadonlyDeep<Camera>);
    getValues(controlName: ControlName): Promise<ReadonlyDeep<ControlValues>>;
    getRange(controlName: ControlName): Promise<ReadonlyDeep<ControlRange>>;
    setValues(controlName: ControlName, values: readonly ControlValue[]): Promise<void>;
    getControlNames(): Promise<readonly ControlName[]>;
    getRanges(): Promise<ReadonlyDeep<ControlRanges>>;
    getSettableControls(): Promise<ReadonlyDeep<ControlsValues>>;
    setControls(configuration: ReadonlyDeep<UvccControls>): Promise<void>;
}
