import { ReadonlyDeep } from "type-fest";
import Output from "./output";
import { CommandHandlerArgumentNames, CommandName, Commands } from "./types/command";
export default class CommandHandlers {
    private readonly output;
    private readonly commands;
    constructor(output: Output, commands: ReadonlyDeep<Commands>);
    has(commandName: CommandName): Promise<boolean>;
    execute(commandName: CommandName, ...args: readonly unknown[]): Promise<unknown>;
    getArguments(commandName: CommandName): Promise<CommandHandlerArgumentNames[]>;
}
