import { ReadonlyDeep } from "type-fest";
import CameraFactory from "./camera-factory";
import CameraHelperFactory from "./camera-helper-factory";
import CommandHandlers from "./command-handlers";
import Output from "./output";
import { RuntimeConfiguration } from "./runtime-configurator";
export default class CommandManager {
    private readonly output;
    private readonly cameraFactory;
    private readonly cameraHelperFactory;
    private readonly commandHandlers;
    constructor(output: Output, cameraFactory: CameraFactory, cameraHelperFactory: CameraHelperFactory, commandHandlers: CommandHandlers);
    execute(runtimeConfig: ReadonlyDeep<RuntimeConfiguration>): Promise<void>;
}
